Page MenuHomePhabricator

ZeroTier integration
Closed, WontfixPublicFEATURE REQUEST

Subscribers
Tokens
"Love" token, awarded by Michael."Like" token, awarded by jdrews."Love" token, awarded by danhusan."Like" token, awarded by Lillecarl.
Assigned To
Authored By
Michael, Nov 17 2017

Description

This FR is meant to keep track of whatever comes out of the short conversation I started on Twitter. I was basically asking for ZeroTier integration in VyOS.

I'd really love to see this implemented! Let's see what happens next.

Details

Difficulty level
Unknown (require assessment)
Version
-
Why the issue appeared?
Will be filled on close

Event Timeline

Michael created this task.Nov 17 2017, 8:21 AM
syncer triaged this task as Wishlist priority.Nov 26 2017, 6:21 PM
danhusan added a subscriber: danhusan.
jdrews added a subscriber: jdrews.
dmbaturin moved this task from Need Triage to Wishlist on the VyOS 1.2 Crux board.May 24 2018, 6:30 PM
syncer closed this task as Wontfix.Jun 22 2018, 10:46 AM
syncer claimed this task.
syncer added a subscriber: syncer.

We got 0 replies from zerotier folks so it looks like they not really interesting in collaboration
therefore we will not be adding support for zerotier into VyOS

jdrews added a comment.Jul 5 2018, 5:37 PM

I posted a comment asking Adam over at ZeroTier to see if he could help with this task.
https://github.com/zerotier/ZeroTierOne/issues/418

jdrews added a comment.EditedSep 1 2018, 4:11 AM

Hmm no movement...

ZeroTier supports Debian. And VyOS is based on Debian.

So I dropped to a shell in VyOS via sudo su and installed ZeroTier on VyOS 999.201706282137. Now it shows an IP addressed ZeroTier interface in iproute2's ip address but if you jump back into the VyOS console show interfaces does not list the new interface. Interesting...

Upon reboot the zt interface is still shown in iproute2 but not in vyos shell. My first thought is it's failing somewhere in here:
https://github.com/vyos/vyatta-cfg-system/blob/current/scripts/system/vyatta_interface_rescan

root@vyos-beta:/home/vyos# ip address | grep zt
4: ztREDACTED: <BROADCAST,MULTICAST,UP,LOWER_UP> mtu 2800 qdisc pfifo_fast state UNKNOWN group default qlen 1000
    inet 192.168.23.2/24 brd 192.168.23.255 scope global ztREDACTED
root@vyos-beta:/home/vyos# exit
exit
vyos@vyos-beta:~$ show interfaces
Codes: S - State, L - Link, u - Up, D - Down, A - Admin Down
Interface        IP Address                        S/L  Description
---------        ----------                        ---  -----------
eth0             192.168.61.3/24                    u/u
lo               127.0.0.1/8                        u/u
                 ::1/128
vtun0            192.168.72.1/24                    u/u
vyos@vyos-beta:~$

Going a bit farther, Quagga is picking up the ZeroTier interface. Confirmed via vtysh

vyos-beta# show interface ztREDACTED
Interface ztREDACTED is up, line protocol detection is disabled
  index 3 metric 1 mtu 2800
  flags: <UP,BROADCAST,RUNNING,MULTICAST>
  HWaddr: da:14:c0:2b:3b:75
  inet 192.168.23.2/24 broadcast 192.168.23.255
  inet6 fe80::d814:c0ff:fe2b:3b75/64
vyos-beta#

For reference here's all I did to get ZeroTier onto a VyOS box:

  1. curl https://install.zerotier.com/ | bash to install ZeroTier
  2. zerotier-cli join YOURNETWORKID to join ZeroTier Network
  3. Authenticate the node on your ZT controller or ZeroTier Central
  4. zerotier-cli listnetworks to check status.
syncer edited projects, added Rejected; removed VyOS 1.2 Crux.Oct 15 2018, 6:30 AM